package tml.pagedebugging.core;

import org.apache.jasper.compiler.TomcatPageHookUtils;

/**
 * Insert tags at the begin and end of the (static) requested resources (file) to help debugging 
 * (compatible with Tomcat 5.5/6.0/7.0, JBoss-Web 2)
 * 
 * @author tminglei
 */
public privileged aspect TomcatStaticPageHook {

	/**
	 * >> Tomcat: insert tags at first and last of the content generated by the statically 
	 * requested resources
	 */
	void around(String fileName, org.apache.jasper.compiler.Node parent) :
		
		//-- pointcuts
		args( fileName, parent ) 
		
		&& call( void org.apache.jasper.compiler.Parser.processIncludeDirective(..) )
		
	{	//-- operations
		
    	TomcatPageHookUtils.tracingBegin(fileName, parent);
    	//--
    	proceed( fileName, parent );
    	//--
    	TomcatPageHookUtils.tracingEnd(fileName, parent);
    	
	}
	
}
